﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO;
using System.Net;
using System.Text.RegularExpressions;

namespace LovciPokladuKlient
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public int idHry;
        public int puvodniTahy;
        public int zbyvajiciTahy;
        public Dictionary<KeyValuePair<int, int>, string> policka; //{[radek, sloupec], obsah}
        public Lovec lovec;

        public MainWindow()
        {
            InitializeComponent();
            idHry = 0;
            zbyvajiciTahy = 0;
            nakreslitMrizku();
            policka = new Dictionary<KeyValuePair<int, int>, string>();
            canvas_herniPlocha.Focus();
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            zacitHru(textBox_server.Text, textBox_port.Text);
            textBox_server.Focusable = false;
            textBox_port.Focusable = false;
            canvas_herniPlocha.Focus();
        }
        public void zacitHru(string server, string port)
        {
            if (idHry == 0)
            {
                WebClient klient = new WebClient();
                Stream odpoved = klient.OpenRead("http://" + server + ":" + port + "/start");
                StreamReader reader = new StreamReader(odpoved);
                idHry = Int32.Parse(reader.ReadLine());
                puvodniTahy = Int32.Parse(reader.ReadLine());
                zbyvajiciTahy = puvodniTahy;
                for (int i = 0; i < 10; i++)
                {
                    string radek = reader.ReadLine();
                    List<string> pole = (from Match m in Regex.Matches(radek, @".{2}") select m.Value).ToList();
                    //foreach (string s in pole)
                    for (int j = 0; j < 10; j++)
                    {
                        KeyValuePair<int, int> par = new KeyValuePair<int, int>(i, j);
                        policka.Add(par, pole[j]);
                    }
                }
                string[] rozdelenyLovec = reader.ReadLine().Split(' ');
                lovec = new Lovec(Int32.Parse(rozdelenyLovec[1]),
                    Int32.Parse(rozdelenyLovec[0]),
                    Int32.Parse(rozdelenyLovec[2]),
                    Int32.Parse(rozdelenyLovec[3]),
                    canvas_herniPlocha
                    );
                label_nesenyPoklad.Content = lovec.nesenyPoklad.ToString();
                label_prinesenyPoklad.Content = lovec.prinesenyPoklad.ToString();
                label_ID.Content = idHry.ToString();
                label_puvodniTahy.Content = puvodniTahy.ToString();
                label_zbyvajiciTahy.Content = zbyvajiciTahy.ToString();
                vykreslitHerniPole();
            }
            else MessageBox.Show("Jedna hra už běží", "Chyba", MessageBoxButton.OK, MessageBoxImage.Error);
        }

        private void vykreslitHerniPole()
        {
            double sirkaPole = canvas_herniPlocha.Width / 10;
            double vyskaPole = canvas_herniPlocha.Height / 10;

            foreach (KeyValuePair<KeyValuePair<int, int>, string> kvp in policka)
            {
                if (kvp.Value == "XX")
                {
                    Rectangle zed = new Rectangle();
                    zed.Width = sirkaPole;
                    zed.Height = vyskaPole;
                    zed.Fill = Brushes.Gray;
                    zed.Stroke = Brushes.Black;
                    zed.StrokeThickness = 0;
                    Canvas.SetTop(zed, kvp.Key.Key * vyskaPole);
                    Canvas.SetLeft(zed, kvp.Key.Value * sirkaPole);
                    canvas_herniPlocha.Children.Add(zed);
                }
                else if (kvp.Value == "++")
                {
                    Rectangle zed = new Rectangle();
                    zed.Width = sirkaPole;
                    zed.Height = vyskaPole;
                    zed.Fill = Brushes.LimeGreen;
                    zed.Stroke = Brushes.Black;
                    zed.StrokeThickness = 0;
                    Canvas.SetTop(zed, kvp.Key.Key * vyskaPole);
                    Canvas.SetLeft(zed, kvp.Key.Value * sirkaPole);
                    canvas_herniPlocha.Children.Add(zed);
                }
                else if (kvp.Value == "--")
                {
                    Rectangle zed = new Rectangle();
                    zed.Width = sirkaPole;
                    zed.Height = vyskaPole;
                    zed.Fill = Brushes.Red;
                    zed.Stroke = Brushes.Black;
                    zed.StrokeThickness = 0;
                    Canvas.SetTop(zed, kvp.Key.Key * vyskaPole);
                    Canvas.SetLeft(zed, kvp.Key.Value * sirkaPole);
                    canvas_herniPlocha.Children.Add(zed);
                }
                else if (kvp.Value != "..")
                {
                    Rectangle zed = new Rectangle();
                    zed.Width = sirkaPole;
                    zed.Height = vyskaPole;
                    zed.Fill = Brushes.Goldenrod;
                    zed.Stroke = Brushes.Brown;
                    zed.StrokeThickness = 0;
                    Canvas.SetTop(zed, kvp.Key.Key * vyskaPole);
                    Canvas.SetLeft(zed, kvp.Key.Value * sirkaPole);
                    canvas_herniPlocha.Children.Add(zed);
                    TextBlock textBlock = new TextBlock();
                    textBlock.Text = kvp.Value.ToString();
                    textBlock.Foreground = Brushes.Black;
                    Canvas.SetTop(textBlock, kvp.Key.Key * vyskaPole);
                    Canvas.SetLeft(textBlock, kvp.Key.Value * sirkaPole);
                    canvas_herniPlocha.Children.Add(textBlock);
                }
                nakreslitMrizku();
                lovec.nakreslitLovce();
                canvas_herniPlocha.Focus();
            }
        }

        private void nakreslitMrizku()
        {
            double sirkaPole = canvas_herniPlocha.Width / 10;
            double vyskaPole = canvas_herniPlocha.Height / 10;

            for (int i = 1; i < 10; i++)
            {
                Line cara = new Line();
                cara.Stroke = Brushes.Black;
                cara.X1 = 0;
                cara.X2 = canvas_herniPlocha.Width;
                cara.Y1 = vyskaPole * i;
                cara.Y2 = vyskaPole * i;
                cara.SnapsToDevicePixels = true;
                cara.SetValue(RenderOptions.EdgeModeProperty, EdgeMode.Aliased);
                cara.StrokeThickness = 1;
                canvas_herniPlocha.Children.Add(cara);
            }
            for (int i = 1; i < 10; i++)
            {
                Line cara = new Line();
                cara.Stroke = Brushes.Black;
                cara.X1 = sirkaPole * i;
                cara.X2 = sirkaPole * i;
                cara.Y1 = 0;
                cara.Y2 = canvas_herniPlocha.Height;
                cara.SnapsToDevicePixels = true;
                cara.SetValue(RenderOptions.EdgeModeProperty, EdgeMode.Aliased);
                cara.StrokeThickness = 1;
                canvas_herniPlocha.Children.Add(cara);
            }
            canvas_herniPlocha.Focus();
        }
        public void posunoutLovce(int smer)
        {
            string pohyb = "";
            lovec.odstranitLovce();
            switch (smer)
            {
                case 1: lovec.sloupec--; pohyb = "L";
                    break;
                case 2: lovec.sloupec++; pohyb = "P";
                    break;
                case 3: lovec.radek++; pohyb = "D";
                    break;
                case 4: lovec.radek--; pohyb = "N";
                    break;
            }
            lovec.nakreslitLovce();
            canvas_herniPlocha.InvalidateVisual();
            canvas_herniPlocha.Focus();

            WebClient klient = new WebClient();
            Stream odpoved = klient.OpenRead("http://" + textBox_server.Text + ":" + textBox_port.Text + "/tah?id=" + idHry + "&pohyb=" + pohyb);
            StreamReader reader = new StreamReader(odpoved);
            if (zbyvajiciTahy > 1)
            {
                reader.ReadLine();
                zbyvajiciTahy = Int32.Parse(reader.ReadLine());
                for (int i = 0; i < 10; i++)
                {
                    reader.ReadLine();
                }
                string[] rozdelenyLovec = reader.ReadLine().Split(' ');
                lovec.radek = Int32.Parse(rozdelenyLovec[1]);
                lovec.sloupec = Int32.Parse(rozdelenyLovec[0]);
                lovec.nesenyPoklad = Int32.Parse(rozdelenyLovec[2]);
                lovec.prinesenyPoklad = Int32.Parse(rozdelenyLovec[3]);
                label_zbyvajiciTahy.Content = zbyvajiciTahy.ToString();
                lovec.odstranitLovce();
                lovec.nakreslitLovce();
                label_nesenyPoklad.Content = lovec.nesenyPoklad.ToString();
                label_prinesenyPoklad.Content = lovec.prinesenyPoklad.ToString();
            }
            else
            {
                string radek = reader.ReadLine();
                if (radek.StartsWith("Konec hry:"))
                {
                    radek = radek.Remove(0, 10);
                    int poklady = Int32.Parse(radek);
                    MessageBox.Show("Sesbíral jsi " + poklady.ToString() + " bodů.");
                    idHry = 0;
                    label_ID.Content = idHry.ToString();
                    zbyvajiciTahy = 0;
                    label_zbyvajiciTahy.Content = zbyvajiciTahy.ToString();
                    canvas_herniPlocha.Children.Clear();
                    nakreslitMrizku();
                    policka.Clear();
                }
                else if (radek.StartsWith("Chyba:"))
                {
                    MessageBox.Show(radek);
                }
            }

        }

        private void canvas_herniPlocha_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Left)
                posunoutLovce(1);
            else if (e.Key == Key.Right)
                posunoutLovce(2);
            else if (e.Key == Key.Down)
                posunoutLovce(3);
            else if (e.Key == Key.Up)
                posunoutLovce(4);
            canvas_herniPlocha.Focus();
        }

        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            canvas_herniPlocha.Focus();
        }

        private void button_novaHra_Click(object sender, RoutedEventArgs e)
        {
            idHry = 0;
            label_ID.Content = idHry.ToString();
            zbyvajiciTahy = 0;
            label_zbyvajiciTahy.Content = zbyvajiciTahy.ToString();
            canvas_herniPlocha.Children.Clear();
            nakreslitMrizku();
            policka.Clear();
            zacitHru(textBox_server.Text, textBox_port.Text);
            textBox_server.Focusable = false;
            textBox_port.Focusable = false;
            canvas_herniPlocha.Focus();
            textBox_port.Focusable = true;
            textBox_server.Focusable = true;

        }
    }
    public class Lovec
    {
        public int radek;
        public int sloupec;
        public int nesenyPoklad;
        public int prinesenyPoklad;
        private Canvas herniPlocha;

        public Lovec(int fRadek, int fSloupec, int fNesenyPoklad, int fPrinesenyPoklad, Canvas fHerniPlocha)
        {
            radek = fRadek;
            sloupec = fSloupec;
            nesenyPoklad = fNesenyPoklad;
            prinesenyPoklad = fPrinesenyPoklad;
            herniPlocha = fHerniPlocha;
        }

        public void nakreslitLovce()
        {
            double sirkaPole = herniPlocha.Width / 10;
            double vyskaPole = herniPlocha.Height / 10;
            Ellipse lovec = new Ellipse();
            lovec.Width = 20;
            lovec.Height = 20;
            lovec.Fill = Brushes.DarkGreen;
            lovec.Stroke = Brushes.Black;
            lovec.StrokeThickness = 0;
            lovec.Uid = "lovec";
            Canvas.SetTop(lovec, radek * vyskaPole - vyskaPole / 4 * 3);
            Canvas.SetLeft(lovec, sloupec * sirkaPole - sirkaPole / 4 * 3);
            herniPlocha.Children.Add(lovec);
            herniPlocha.Focus();
        }
        public void odstranitLovce()
        {
            List<UIElement> seznam = new List<UIElement>();
            foreach (UIElement prvek in herniPlocha.Children)
            {
                if (prvek.Uid.StartsWith("lovec"))
                {
                    seznam.Add(prvek);
                }
            }
            foreach (UIElement prvek in seznam)
            {
                herniPlocha.Children.Remove(prvek);
            }
            herniPlocha.Focus();
        }
    }
}
